//+------------------------------------------------------------------+
//|                                                        ARIMA.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Magenta
//---- input parameters
extern datetime  start=D'2011.11.11';
extern int       period=5;// 
//---- buffers
double Ext[];
int st;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
double fak[100];
double wa[100][100], wb[100], wx[100];
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Ext);
   st=iBarShift(NULL,0,start);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted(), i;
//----
   for(i=st;i>=0;i--)
    {
    calc_fak(i); // 
    prepare_matrix(); // 
    slau(period, wa, wb, wx); // 
    Ext[i]=res_sum(i); //  
    } 
//----
   return(0);
  }
//+------------------------------------------------------------------+
double res_sum(int j)
{                               //Print("*********");
double sum=0;
for(int i=0;i<period;i++)
 {                              //Print(x[i]);
 sum+=Close[i+j]*wx[i];
 }
return(sum); 
}

void calc_fak(int k)
{//Print("*********");
/*int cnt=0;
for(int j=0;j<period+1;j++)
 {
 double s1=0, s2=0;
 for(int i=k;i<period+k;i++) 
  {
  double dif1=Close[i]-Close[i+1];
  double dif2=Close[i+j]-Close[i+j+1];
  s1+=dif1*dif2;
  s2+=dif1*dif1;
  }
 if(s2!=0) fak[cnt]=s1/s2; //Print(fak[cnt]);
 cnt++;
 }*/
double data[][2];
ArrayResize(data,period);
int i,j;
for(i=0;i<period;i++)
 {
 data[i][0]=Close[k+i];
 }
for(i=0;i<period+1;i++)
 {
 for(j=0;j<period;j++)
  {
  data[j][1]=Close[k+j+i];
  }
 fak[i]=auto_corr(data); //Print(fak[i]);
 } 
}

void slau(int n, double &a[][], double &b[], double &x[])
{       
int i,j,k;
//*********
/*Print("*********");
for(i=0;i<period;i++)
 {
 string str="";
 for(j=0;j<period;j++) str=str+ " "+ DoubleToStr(a[i][j],4);
 str=str+" ** "+DoubleToStr(b[i],4);
 Print(str);
 }*/
//*********                                                                         
double h;
for(i=0;i<n;i++)
 {
 for(j=i+1;j<n+1;j++)
  {
  if(a[i][i]!=0) a[j][i]=-a[j][i]/a[i][i]; 
  else a[j][i]=0;
  for(k=i+1;k<n+1;k++) a[j][k]=a[j][k]+a[j][i]*a[i][k]; 
  b[j]=b[j]+a[j][i]*b[i]; 
  }
 } 
if(a[n-1][n-1]!=0) x[n]=b[n-1]/a[n-1][n-1];  
else x[n]=0;
for(i=n-1;i>=0;i--)
 {
 h=b[i];
 for(j=i;j<n;j++) h-=x[j]*a[i][j];
 if(a[i][i]!=0) x[i]=h/a[i][i];
 else x[i]=0;
 }
//***********
//Print("*********");
//for(i=0;i<n;i++) Print("x",i,"=",x[i]); 
} 

void prepare_matrix()
{
ArrayInitialize(wa,0);     
ArrayInitialize(wb,0);   
ArrayInitialize(wx,0);                      //Print("**********");
int i, j, cnt=0;
for(i=0;i<period;i++)
 {      
 cnt=i;                //string pr="";
 for(j=0;j<i;j++)
  {
  wa[i][j]=fak[cnt]; 
  cnt--;                //pr=pr+DoubleToStr(a[i][j], 2);pr=pr+" ";
  }
 cnt=0; 
 for(j=i;j<period;j++)
  {
  wa[i][j]=fak[cnt];   
  cnt++;               // pr=pr+DoubleToStr(a[i][j], 2);pr=pr+" ";
  }                     //Print(pr);
 } 
//**********  
for(i=0;i<period;i++) {wb[i]=-1.0*fak[i+1]; /*Print(b[i]);*/}
}

double auto_corr(double &data[][])
{
double sum1=0, sum2=0;
double dev=0, q1=0, q2=0;
int j=0, i=0;
for(j=0;j<period;j++)
 {
 sum1+=data[j][0];
 sum2+=data[j][1];
 }
sum1/=period;
sum2/=period; 
//*************
for(j=0;j<period;j++)
 {
 dev+=(data[j][0]-sum1)*(data[j][1]-sum2);
 q1+=(data[j][0]-sum1)*(data[j][0]-sum1);
 q2+=(data[j][1]-sum2)*(data[j][1]-sum2);
 }
//************* 
double r=MathSqrt(q1)*MathSqrt(q2);
if(r!=0) return(dev/r);
else return(0);
}